Difficulty:

Description

Motivation

We only support "OpenID" and "Fake" authentication so far. In #66703 we can see the problem with the high reliance on OpenlD. In
multiple places we are happy users of what github provides. We should research how feasible it is to support github as authentication
provider, same as many other services do.

History

#1 - 2020-06-02 10:39 - cdywan
- Status changed from Workable to In Progress
- Assignee set to cdywan

- Target version changed from Ready to Current Sprint

#2 - 2020-06-02 17:16 - cdywan

e OAuth 2.0 which GitHub supports is pretty straightforward. Request a token via GET, get a temporary code and turn that into an access token.
An application has to be registered. The domain has to match or the login will fail.

Getting user details like nickname/fullname/email requires gitHub-specific API, although that's just one more GET.

Mojolicious::Plugin::OAuth2 looks to make OAuth 2.0 easy to implement. Bonus points for supporting various other services by design.

We could get the gravatar avatar and use it - this would be a new feature.

My proof of concept actually turned into a working implementation pretty quickly.

On a side note, we could hypothetically use GitHub credentails for needle editing. Although | didn't explore this further.

#3 - 2020-06-03 06:34 - okurz

¢ We could get the gravatar and use it - this would be a new feature.

We already support gravatar. Isn't that only based on the email?

#4 - 2020-06-03 11:16 - cdywan

okurz wrote:

e We could get the gravatar and use it - this would be a new feature.

We already support gravatar. Isn't that only based on the email?

Sorry, | actually meant avatar there. The email is optional if the user chooses to hide it. So using the provided avatar would work better in that case.

#5 - 2020-06-05 14:49 - cdywan

Note: tinita was so kind to me help out by preparing a package for the OAuth 2.0 plugin: https://build.opensuse.org/request/show/811723

#6 - 2020-06-05 15:30 - tinita

The request for Factory is here: https://build.opensuse.org/request/show/811785 (still in review)
https://progress.opensuse.org/issues/66703
https://developer.github.com/apps/building-oauth-apps/authorizing-oauth-apps
https://github.com/settings/developers
https://metacpan.org/pod/Mojolicious::Plugin::OAuth2
https://github.com/os-autoinst/openQA/pull/3150
progress.opensuse.org/users/33482
https://build.opensuse.org/request/show/811723
https://build.opensuse.org/request/show/811785

#7 - 2020-06-26 10:06 - okurz

https://build.opensuse.org/request/show/811785 is accepted. PR has has at least still one open unresolved comment

https://github.com/o0s-autoinst/openQA/pull/3150#discussion_r439386640

#8 - 2020-07-06 15:46 - cdywan

- Status changed from In Progress to Feedback

https://github.com/o0s-autoinst/openQA/pull/3150

The Feedback here is not going to be observed in production instances, as we don't plan to enable it for now. Although we might see some on other
instances so I'll use the status like usual.

Btw docs are/will be here soon http://open.qa/docs/#authentication

#9 - 2020-07-16 13:04 - okurz

- Status changed from Feedback to Resolved

cdywan you provided a minor fix with https://github.com/os-autoinst/openQA/pull/3258 which has been merged and is active.
http://open.qa/docs/#authentication is updated and we do not need to verify this on our production instances so considered "Resolved"
